; **************************************************************************
; === Define constants ===
; **************************************************************************
!define /date VER	"%Y.%m.%d.%H"
; !define VER 		"0.0.0.0"	; version of launcher
!define APPNAME 	"KeePass Password Safe 1.x"	; complete name of program
!define APP 		"KeePass"	; short name of program without space and accent  this one is used for the final executable an in the directory structure
!define APPEXE 		"KeePass.exe"	; main exe name
!define APPDIR 		"App\KeePass1"	; main exe relative path
!define APPSWITCH 	``	; some default Parameters

; **************************************************************************
; === Best Compression ===
; **************************************************************************
SetCompressor /SOLID lzma
SetCompressorDictSize 32

; **************************************************************************
; === Includes ===
; **************************************************************************
!include "..\_Include\Launcher.nsh" 
!include "TextReplace.nsh"

; **************************************************************************
; === Set basic information ===
; **************************************************************************
Name "${APPNAME} Portable"
OutFile "..\..\..\${APP}Portable\${APP}1Portable.exe"
Icon "${APP}.ico"

; **************************************************************************
; === MultiLang ===
; **************************************************************************
!include "LogicLib.nsh"
Var LNG
Function MultiLang
ReadINIStr $0 "$EXEDIR\${APPDIR}\${APP}.ini" "KeePass" "KeeLanguage"
StrCmp $0 "" 0 langset
System::Call 'kernel32::GetUserDefaultLangID() i .r0'
${If} $0 == "1033"
StrCpy $LNG "Standard"

${ElseIf} $0 == "2052"
${AndIf} ${FileExists} "$EXEDIR\${APPDIR}\Chinese_Simplified.lng"
StrCpy $LNG "Chinese_Simplified"
${ElseIf} $0 == "1028"
${AndIf} ${FileExists} "$EXEDIR\${APPDIR}\Chinese_Traditional.lng"
StrCpy $LNG "Chinese_Traditional"
${ElseIf} $0 == "1030"
${AndIf} ${FileExists} "$EXEDIR\${APPDIR}\Danish.lng"
StrCpy $LNG "Danish"
${ElseIf} $0 == "1043"
${AndIf} ${FileExists} "$EXEDIR\${APPDIR}\Dutch.lng"
StrCpy $LNG "Dutch"
${ElseIf} $0 == "1036"
${AndIf} ${FileExists} "$EXEDIR\${APPDIR}\French.lng"
StrCpy $LNG "French"
${ElseIf} $0 == "1031"
${AndIf} ${FileExists} "$EXEDIR\${APPDIR}\German.lng"
StrCpy $LNG "German"
${ElseIf} $0 == "1038"
${AndIf} ${FileExists} "$EXEDIR\${APPDIR}\Hungarian.lng"
StrCpy $LNG "Hungarian"
${ElseIf} $0 == "1040"
${AndIf} ${FileExists} "$EXEDIR\${APPDIR}\Italian.lng"
StrCpy $LNG "Italian"
${ElseIf} $0 == "1041"
${AndIf} ${FileExists} "$EXEDIR\${APPDIR}\Japanese.lng"
StrCpy $LNG "Japanese"
${ElseIf} $0 == "1063"
${AndIf} ${FileExists} "$EXEDIR\${APPDIR}\Lithuanian.lng"
StrCpy $LNG "Lithuanian"
${ElseIf} $0 == "1045"
${AndIf} ${FileExists} "$EXEDIR\${APPDIR}\Polish.lng"
StrCpy $LNG "Polish"
${ElseIf} $0 == "2070"
${AndIf} ${FileExists} "$EXEDIR\${APPDIR}\Portuguese_PT.lng"
StrCpy $LNG "Portuguese_PT"
${ElseIf} $0 == "1049"
${AndIf} ${FileExists} "$EXEDIR\${APPDIR}\Russian.lng"
StrCpy $LNG "Russian"
${ElseIf} $0 == "1051"
${AndIf} ${FileExists} "$EXEDIR\${APPDIR}\Slovak.lng"
StrCpy $LNG "Slovak"
${ElseIf} $0 == "1034"
${AndIf} ${FileExists} "$EXEDIR\${APPDIR}\Spanish.lng"
StrCpy $LNG "Spanish"
${ElseIf} $0 == "1053"
${AndIf} ${FileExists} "$EXEDIR\${APPDIR}\Swedish.lng"
StrCpy $LNG "Swedish"
${ElseIf} $0 == "1055"
${AndIf} ${FileExists} "$EXEDIR\${APPDIR}\Turkish.lng"
StrCpy $LNG "Turkish"
${ElseIf} $0 == "1058"
${AndIf} ${FileExists} "$EXEDIR\${APPDIR}\Ukrainian.lng"
StrCpy $LNG "Ukrainian"

${Else}
StrCpy $LNG "Standard"
${EndIf}
WriteINIStr "$EXEDIR\${APPDIR}\${APP}.ini" "KeePass" "KeeLanguage" "$LNG"
langset:
FunctionEnd

; **************************************************************************
; === Other Actions ===
; **************************************************************************
Function Init
Rename "$EXEDIR\Data\${APP}1\${APP}.ini" "$EXEDIR\${APPDIR}\${APP}.ini"

ReadINIStr $0 "$EXEDIR\Data\${APP}Portable.ini" "${APP}Portable" "LastDirectory"
StrCpy $1 $0 3
StrCpy $2 $EXEDIR 3
StrCmp $1 $2 +3
	${textreplace::ReplaceInFile} "$EXEDIR\${APPDIR}\${APP}.ini" "$EXEDIR\${APPDIR}\${APP}.ini" "$1" "$2" "" $0
	${textreplace::Unload}

WriteINIStr "$EXEDIR\${APPDIR}\${APP}.ini" "KeePass" "KeeCheckForUpdate" "False"
WriteINIStr "$EXEDIR\${APPDIR}\${APP}.ini" "KeePass" "KeeCheckForUpdateConfigured" "True"
; WriteINIStr "$EXEDIR\${APPDIR}\${APP}.ini" "KeePass" "KeeLastDir" "$EXEDIR\${APPDIR}"

FunctionEnd

Function Close
CreateDirectory "$EXEDIR\Data\${APP}1"
Rename "$EXEDIR\${APPDIR}\${APP}.ini" "$EXEDIR\Data\${APP}1\${APP}.ini"

FunctionEnd

; **************************************************************************
; ==== Running ====
; **************************************************************************

Section "Main"

	Call CheckStart

	Call Init
	Call MultiLang

		Call SplashLogo
		Call Launch

	Call Restore

SectionEnd

Function Restore

	Call Close


FunctionEnd

; **************************************************************************
; === Run Application ===
; **************************************************************************
Function Launch
SetOutPath "$EXEDIR\${APPDIR}" ; Lock Rename!
${GetParameters} $0
ExecWait `"$EXEDIR\${APPDIR}\${APPEXE}"${APPSWITCH} $0`
WriteINIStr "$EXEDIR\Data\${APP}Portable.ini" "${APP}Portable" "GoodExit" "true"
newadvsplash::stop
FunctionEnd
