; **************************************************************************
; === Define constants ===
; **************************************************************************
!define /date VER	"%Y.%m.%d.%H"
; !define VER 		"0.0.0.0"	; version of launcher
!define APPNAME 	"KeePass Password Safe"	; complete name of program
!define APP 		"KeePass"	; short name of program without space and accent  this one is used for the final executable an in the directory structure
!define APPEXE 		"KeePass.exe"	; main exe name
!define APPDIR 		"App\KeePass2"	; main exe relative path
!define APPSWITCH 	``	; some default Parameters

; **************************************************************************
; === Best Compression ===
; **************************************************************************
SetCompressor /SOLID lzma
SetCompressorDictSize 32

; **************************************************************************
; === Includes ===
; **************************************************************************
!include "..\_Include\Launcher.nsh" 

; **************************************************************************
; === Set basic information ===
; **************************************************************************
Name "${APPNAME} Portable"
OutFile "..\..\..\${APP}Portable\${APP}2Portable.exe"
Icon "${APP}.ico"

; **************************************************************************
; === MultiLang ===
; **************************************************************************
!include "LogicLib.nsh"
Var LNG
Function MultiLang
	nsisXML::create
	nsisXML::load "$EXEDIR\${APPDIR}\KeePass.config.xml"
	nsisXML::select "/Configuration/Application/LanguageFile"
	nsisXML::getText
	StrCpy $LNG "$3"
	nsisXML::save "$EXEDIR\${APPDIR}\KeePass.config.xml"
StrCmp $LNG "" 0 langset
System::Call 'kernel32::GetUserDefaultLangID() i .r0'
${If} $0 == "1033"
StrCpy $LNG "English"

${ElseIf} $0 == "2052"
${AndIf} ${FileExists} "$EXEDIR\${APPDIR}\Chinese_Simplified.lngx"
StrCpy $LNG "Chinese_Simplified"
${ElseIf} $0 == "1028"
${AndIf} ${FileExists} "$EXEDIR\${APPDIR}\Chinese_Traditional.lngx"
StrCpy $LNG "Chinese_Traditional"
${ElseIf} $0 == "1030"
${AndIf} ${FileExists} "$EXEDIR\${APPDIR}\Danish.lngx"
StrCpy $LNG "Danish"
${ElseIf} $0 == "1043"
${AndIf} ${FileExists} "$EXEDIR\${APPDIR}\Dutch.lngx"
StrCpy $LNG "Dutch"
${ElseIf} $0 == "1036"
${AndIf} ${FileExists} "$EXEDIR\${APPDIR}\French.lngx"
StrCpy $LNG "French"
${ElseIf} $0 == "1031"
${AndIf} ${FileExists} "$EXEDIR\${APPDIR}\German.lngx"
StrCpy $LNG "German"
${ElseIf} $0 == "1038"
${AndIf} ${FileExists} "$EXEDIR\${APPDIR}\Hungarian.lngx"
StrCpy $LNG "Hungarian"
${ElseIf} $0 == "1040"
${AndIf} ${FileExists} "$EXEDIR\${APPDIR}\Italian.lngx"
StrCpy $LNG "Italian"
${ElseIf} $0 == "1041"
${AndIf} ${FileExists} "$EXEDIR\${APPDIR}\Japanese.lngx"
StrCpy $LNG "Japanese"
${ElseIf} $0 == "1063"
${AndIf} ${FileExists} "$EXEDIR\${APPDIR}\Lithuanian.lngx"
StrCpy $LNG "Lithuanian"
${ElseIf} $0 == "1045"
${AndIf} ${FileExists} "$EXEDIR\${APPDIR}\Polish.lngx"
StrCpy $LNG "Polish"
${ElseIf} $0 == "2070"
${AndIf} ${FileExists} "$EXEDIR\${APPDIR}\Portuguese_PT.lngx"
StrCpy $LNG "Portuguese_PT"
${ElseIf} $0 == "1049"
${AndIf} ${FileExists} "$EXEDIR\${APPDIR}\Russian.lngx"
StrCpy $LNG "Russian"
${ElseIf} $0 == "1051"
${AndIf} ${FileExists} "$EXEDIR\${APPDIR}\Slovak.lngx"
StrCpy $LNG "Slovak"
${ElseIf} $0 == "1034"
${AndIf} ${FileExists} "$EXEDIR\${APPDIR}\Spanish.lngx"
StrCpy $LNG "Spanish"
${ElseIf} $0 == "1053"
${AndIf} ${FileExists} "$EXEDIR\${APPDIR}\Swedish.lngx"
StrCpy $LNG "Swedish"
${ElseIf} $0 == "1055"
${AndIf} ${FileExists} "$EXEDIR\${APPDIR}\Turkish.lngx"
StrCpy $LNG "Turkish"
${ElseIf} $0 == "1058"
${AndIf} ${FileExists} "$EXEDIR\${APPDIR}\Ukrainian.lngx"
StrCpy $LNG "Ukrainian"

${Else}
StrCpy $LNG "English"
${EndIf}
	nsisXML::create
	nsisXML::load "$EXEDIR\${APPDIR}\KeePass.config.xml"
	nsisXML::select "/Configuration/Application/LanguageFile"
	nsisXML::setText "$LNG.lngx"
	nsisXML::save "$EXEDIR\${APPDIR}\KeePass.config.xml"
langset:
FunctionEnd

; **************************************************************************
; === Other Actions ===
; **************************************************************************
Function Init
IfFileExists "$EXEDIR\Data\${APP}2\KeePass.config.xml" +3
	CreateDirectory "$EXEDIR\Data\${APP}2"
	File "/oname=$EXEDIR\Data\${APP}2\KeePass.config.xml" "KeePass.config.xml"

Rename "$EXEDIR\Data\${APP}2\KeePass.config.xml" "$EXEDIR\${APPDIR}\KeePass.config.xml"
	nsisXML::create
	nsisXML::load "$EXEDIR\${APPDIR}\KeePass.config.xml"
	nsisXML::select "/Configuration/Meta/PreferUserConfiguration"
	nsisXML::setText "false"
	nsisXML::select "/Configuration/Meta/OmitItemsWithDefaultValues"
	nsisXML::setText "true"
	nsisXML::select "/Configuration/Application/Start/CheckForUpdate"
	nsisXML::setText "false"
	nsisXML::select "/Configuration/Application/Start/CheckForUpdateConfigured"
	nsisXML::setText "true"
	nsisXML::save "$EXEDIR\${APPDIR}\KeePass.config.xml"

FunctionEnd

Function Close
CreateDirectory "$EXEDIR\Data\${APP}2"
Rename "$EXEDIR\${APPDIR}\KeePass.config.xml" "$EXEDIR\Data\${APP}2\KeePass.config.xml"

FunctionEnd

; **************************************************************************
; ==== Running ====
; **************************************************************************

Section "Main"

	Call CheckStart

	Call Init
	Call MultiLang

		Call SplashLogo
		Call Launch

	Call Restore

SectionEnd

Function Restore

	Call Close


FunctionEnd

; **************************************************************************
; === Run Application ===
; **************************************************************************
Function Launch
SetOutPath "$EXEDIR\${APPDIR}" ; Lock Rename!
${GetParameters} $0
ExecWait `"$EXEDIR\${APPDIR}\${APPEXE}"${APPSWITCH} $0`
WriteINIStr "$EXEDIR\Data\${APP}Portable.ini" "${APP}Portable" "GoodExit" "true"
newadvsplash::stop
FunctionEnd
